/*  
    VTun - Virtual Tunnel over TCP/IP network.

    Copyright (C) 1998-2000  Maxim Krasnyansky <max_mk@yahoo.com>

    VTun has been derived from VPPP package by Maxim Krasnyansky. 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 */

/*
 * sniff_dev.c,v 1.0 2003/04/06 22:10:00 silvio
 */ 

#include "config.h"

#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <syslog.h>

#include "vtun.h"
#include "lib.h"

#include <sys/types.h>
#include <sys/socket.h>
#include <linux/if_ether.h>
#include <linux/if.h>
#include <sys/ioctl.h>

struct ifreq ifr;

int sniff_open(char *dev)
{
    int i, fd;

    if( *dev )
       if ((fd = socket(AF_INET, SOCK_PACKET, htons(ETH_P_ALL))) < 0)
       {
          perror("Can't open socket: ");
          return -1;
       }

    /* set promisc mode on device */
    strcpy(ifr.ifr_name, dev);
    ioctl(fd, SIOCGIFFLAGS, &ifr);
    ifr.ifr_flags |= IFF_PROMISC;
/* add if's */
    ioctl(fd, SIOCGIFFLAGS, &ifr);
    ioctl(fd, SIOCGIFHWADDR,&ifr);
    
    return 0;
}

int sniff_close(int fd, char *dev)
{
    return close(fd);
}

/* Write frames to TAP device */
int sniff_write(int fd, char *buf, int len)
{
    return write(fd, buf, len);
}

/* Read frames from TAP device */
int sniff_read(int fd, char *buf, int len)
{
    int rc;

    if(rc=read(fd,buf,len))
    {
        if(!memcmp(((struct ethhdr*)buf)->h_source,ifr.ifr_hwaddr.sa_data,ETH_ALEN))
          return rc;
    }

    return 0;
}
